;
; IDL Event Callback Procedures
; Mock_Star_Tool_eventcb
;
; Generated on:	01/13/2017 13:56.00
;
; Empty stub procedure used for autoloading.
;
pro Mock_Star_Tool_eventcb
end
;------------------------------------------
pro Mock_Star_Tool_PostCreation, wWidget, _EXTRA=_VWBExtra_
	;
	;	get directory from which the software was launched
	;
	CD, CURRENT=this_dir
	;
	;	set up and clear summary structure
	;
	summary_struct = {	root_dir:				'none',		$	root of directory structure
						last_dir:				'none',		$   last raw data directory accessed
						lu_log:					0L,			$	lu of log file
						log_path:				'',			$ 	pathname to the log file
						this_dir:			this_dir, 		$	launch directory
						this_tab:				0L			$	current tab number
						;
					  }
	;
	widget_struct = {	  $	;				;
							;	wids - Tab 0 first
							;
							Nstars_Textbox_wid:					0L, $
								Nstars:						 1000L, $
							Beta_Textbox_wid:					0L, $
								Beta:						   0.2, $
							M0_Textbox_wid:						0L, $
								M0:						 	   7.0, $
							M1_Textbox_wid:						0L, $
								M1:						 	  17.0, $
							Mag_Offset_Textbox_wid:				0L, $
								Mag_Offset:					   0.0, $
							P0_Textbox_wid:						0L, $
								P0:    						   0.0, $
							P1_Textbox_wid:						0L, $
								P1:							   5.0, $
							EPA0_Textbox_wid:					0L, $
								EPA0:					       0.0, $
							EPA1_Textbox_wid:					0L, $
								EPA1:  					     180.0, $
							Run_Number_Textbox_wid:				0L, $
								Run_Number:						1L, $
							Current_Trial_Name_Textbox_wid:		0L, $
								Current_Trial_Name:         'no root', $
							Current_Path_Textbox_wid:			0L, $
								Current_Path:			    'no path', $
							History_Textbox_wid:				0L, $
							Summary_Textbox_wid:				0L, $
							;
							Half_Half_Checkbox_wid:				0L, $
								Half_Half_Flag:					0L, $
							Save_DS9_Reg_Checkbox_wid:			0L, $
								Save_DS9_Reg_Flag:				1L, $
							No_HWP_Checkbox_wid:				0L, $
								No_HWP_Flag:					0L, $
							;
							Change_Trial_Root_Button_wid:		0L, $
							Start_Creation_Button_wid:			0L, $
							Exit_Button_wid:					0L, $
							;
							Poisson_Checkbox_wid:				0L, $
								Poisson_Flag:					0L, $
							;
							Creation_Perfmeter_Window_wid:		0L, $
							;
							;	top level base
							;
							Tab_Base_wid:						0L, $
							MST_TLB_wid:						0L, $
							;
							;	textbox buffers
							;
							Term_textbox_nch:           intarr(20), $
							Term_textbox_buffer:  	  strarr(20,80), $
							;
							;	Tab 1 next
							;
							Source_Directory_Textbox_wid:		0L, $
								Source_Directory_Name: 'no source', $
							File_Copy_Textbox_wid:				0L, $
								File_Copy_List:		    strarr(17), $
							Destination_Directory_Textbox_wid:  0L, $
								Destination_Directory:  'no destination', $
							Copy_Results_Textbox_wid:			0L, $
								Copy_Results:			'not started', $
							Change_Trial_Run_Directory_Button_wid: 0L, $
							Change_Destination_Directory_Button_wid: 0L, $
							Start_File_Copy_Button_wid:			0L, $
							Copy_Results_Window_wid:			0L, $
							;
							;	Tab 2 next
							;
							T2_PPOL_Root_Dir_Textbox_wid:		0L, $
								T2_PPOL_Root_Dir:		'no root',  $
							T2_Obs_Root_Name_Textbox_wid:		0L, $
								T2_Obs_Root_Name:		'no obs name', $
							T2_Obs_Root_List_Listbox_wid:		0L, $
								T2_Obs_Root_List:		strarr(10), $
								T2_Obs_Root_Ind:				0L, $
							T2_Destination_Directory_Textbox_wid: 0L, $
								T2_Destination_Directory: 'no dest', $
							T2_Change_PPOL_Root_Button_wid:		0L, $
							T2_Change_Destination_Directory_Button_wid: 0L, $
							T2_Start_File_Fetch_Button_wid:		0L $
							;
						}

	PTR_summary = PTR_NEW(summary_struct,/NO_COPY)
	PTR_wid = PTR_NEW(widget_struct,/NO_COPY)
    ;
    ;	load the pointer(s) into the pointer structure
    ;
    PTR_struct = {PTR_summary: PTR_summary, PTR_wid: PTR_wid}
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=PTR_struct
    ;
end

;-----------------------------------------------------------------
pro Exit_Action, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct	;	close log file
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	;
	;	 close the log
	;
	print_text, Event, 'Closing Log file at '+SYSTIME()
	;
	FREE_LUN, (*s_ptr).lu_log
	;
	;free the pointers
	;
	;	and then the full structure pointers
	;
	PTR_FREE, w_ptr
	PTR_FREE, s_ptr
	;
	WIDGET_CONTROL, Event.top, /DESTROY
end
;
;-----------------------------------------------------------------
pro Mock_Star_Tool_Realize, wWidget
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	;
	;	load all the widget IDs
	;
	;	need to pass an event structure:
	;
	event = {top: wWidget}
	get_wids, event
	;
	;	reread the pointer structure to get updated wids
	;
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	;	create the log file name and open it
	;
	Create_New_Log_File, Event
	;
	print_text, event, "Mock Star Tool - Initialized!"
	;
	;	print summary
	;
	Summary_print, wWidget
	;
	;	Fill default values, or updated, as needed
	;
	split_path, Event, (*s_ptr).this_dir, root_path, root_name
	;
	(*w_ptr).Current_Path = root_path
	(*w_ptr).Current_Trial_Name = root_name
	print_text, Event, "New Trial Root Path = "+root_path
	print_text, Event, "New Trial Root Name = "+root_name
	;
	;	clear some buffers
	;
	(*w_ptr).File_Copy_List = replicate('no file',17)
	(*w_ptr).T2_Obs_Root_List = replicate('no root',10)
	;
	Show_Checkboxes, Event
	Show_Textboxes, Event
	;
	;	and any perfmeter windows
	;
	Clear_Perfmeters, Event
	;
end
;
;--------------------------------------------------------------
pro split_path, Event, full_path, root_path, root_name
	;
	;	splits a full directory path name into a root_path (one directory up)
	;	and a root_name (name of the current directory)
	;
	parts = STRSPLIT(full_path, PATH_SEP(), /extract, COUNT=np)
	if(np gt 0) then begin
		root_path = ''
		root_name = parts[np-1]
		for i=0,np-2 do begin
			root_path += parts[i] + PATH_SEP()
		endfor
	endif
end
;
;----------------------------------------------------------------
;
pro Show_Textboxes, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	for each Texbox window, put the value of the buffer into it
	;
	;	tab 0
	;
	WIDGET_CONTROL, (*w_ptr).Nstars_Textbox_wid, SET_VALUE=STRING(format='(I5)',(*w_ptr).Nstars)
	WIDGET_CONTROL, (*w_ptr).Beta_Textbox_wid, SET_VALUE=STRING(format='(F6.3)',(*w_ptr).Beta)
	WIDGET_CONTROL, (*w_ptr).M0_Textbox_wid, SET_VALUE=STRING(format='(F6.2)',(*w_ptr).M0)
	WIDGET_CONTROL, (*w_ptr).M1_Textbox_wid, SET_VALUE=STRING(format='(F6.2)',(*w_ptr).M1)
	WIDGET_CONTROL, (*w_ptr).Mag_Offset_Textbox_wid, SET_VALUE=STRING(format='(F6.4)',(*w_ptr).Mag_Offset)
	WIDGET_CONTROL, (*w_ptr).P0_Textbox_wid, SET_VALUE=STRING(format='(F6.1)',(*w_ptr).P0)
	WIDGET_CONTROL, (*w_ptr).P1_Textbox_wid, SET_VALUE=STRING(format='(F6.1)',(*w_ptr).P1)
	WIDGET_CONTROL, (*w_ptr).EPA0_Textbox_wid, SET_VALUE=STRING(format='(F6.1)',(*w_ptr).EPA0)
	WIDGET_CONTROL, (*w_ptr).EPA1_Textbox_wid, SET_VALUE=STRING(format='(F6.1)',(*w_ptr).EPA1)
	WIDGET_CONTROL, (*w_ptr).Current_Trial_Name_Textbox_wid, SET_VALUE=(*w_ptr).Current_Trial_Name
	WIDGET_CONTROL, (*w_ptr).Current_Path_Textbox_wid, SET_VALUE=(*w_ptr).Current_Path
	WIDGET_CONTROL, (*w_ptr).Run_Number_Textbox_wid, SET_VALUE=STRING(format='(I2)',(*w_ptr).Run_Number)
	;
	;	tab 1
	;
	WIDGET_CONTROL, (*w_ptr).Source_Directory_Textbox_wid, SET_VALUE=(*w_ptr).Source_Directory_Name
	WIDGET_CONTROL, (*w_ptr).File_Copy_Textbox_wid, SET_VALUE=FILE_BASENAME((*w_ptr).File_Copy_List)
	WIDGET_CONTROL, (*w_ptr).Destination_Directory_Textbox_wid, SET_VALUE=(*w_ptr).Destination_Directory
	WIDGET_CONTROL, (*w_ptr).Copy_Results_Textbox_wid, SET_VALUE=(*w_ptr).Copy_Results
	;
	;	tab 2
	;
	WIDGET_CONTROL, (*w_ptr).T2_PPOL_Root_Dir_Textbox_wid, SET_VALUE=(*w_ptr).T2_PPOL_Root_dir
	WIDGET_CONTROL, (*w_ptr).T2_Obs_Root_Name_Textbox_wid, SET_VALUE=(*w_ptr).T2_Obs_Root_Name
	WIDGET_CONTROL, (*w_ptr).T2_Obs_Root_List_Listbox_wid, SET_VALUE=(*w_ptr).T2_Obs_Root_List
	WIDGET_CONTROL, (*w_ptr).T2_Destination_Directory_Textbox_wid, SET_VALUE=(*w_ptr).T2_Destination_Directory
end
;
;--------------------------------------------------------------
;
pro Show_Checkboxes, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	for each checkbox, show its initial value
	;
	WIDGET_CONTROL, (*w_ptr).Half_Half_Checkbox_wid, SET_BUTTON=(*w_ptr).Half_Half_Flag
	WIDGET_CONTROL, (*w_ptr).Save_DS9_Reg_Checkbox_wid, SET_BUTTON=(*w_ptr).Save_DS9_Reg_Flag
	WIDGET_CONTROL, (*w_ptr).No_HWP_Checkbox_wid, SET_BUTTON=(*w_ptr).No_HWP_Flag
	WIDGET_CONTROL, (*w_ptr).Poisson_Checkbox_wid, SET_BUTTON=(*w_ptr).Poisson_Flag
end
;
;-----------------------------------------------------------------
pro Clear_Perfmeters, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	clears all performance meters to 17 bars of gray
	;
	colors = strarr(17)
	colors[*] = 'gray'
	;
	LED_stack, (*w_ptr).Creation_Perfmeter_Window_wid, colors
	LED_stack, (*w_ptr).Copy_Results_Window_wid, colors
end
;
;-----------------------------------------------------------------
pro Tab_Handler, Event
	;
	;	for now report the tab number - later, will connect to changes as needed
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	wid = (*w_ptr).Tab_Base_wid
	tab = WIDGET_INFO(wid,/TAB_CURRENT)
	;
	(*s_ptr).this_tab = tab
	;
	case tab of
		0: print_text, Event, "Mock Star Generation Page Selected"
		1: print_text, Event, "Mock Star Image Upload Page Selected"
		2: print_text, Event, "PPOL Results Download Page Selected"
		3: print_text, Event, "Mock Star Matching and Analysis Page Selected"
	endcase
	;
	;	update all textboxes and checkboxes
	;
	Show_Textboxes, Event
	Show_Checkboxes, Event
	;
	;	and clear all perfmeters
	;
	Clear_Perfmeters, Event
	;
end
;
;-----------------------------------------------------------------
pro Tab_0_Handler, Event
	;
	;	handles button and checkbox events generated on the first tab
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	figure out which button was pushed
	;
	buttons = [	"Change_Trial_Root_Button", $
				"Start_Creation_Button", $
				"Half_Half_Checkbox",$
                "Save_DS9_Reg_Checkbox",$
				"No_HWP_Checkbox", $
				"Poisson_Checkbox" $
			   ]
	wid_button = Event.id
	n_buttons = N_ELEMENTS(buttons)
	button_wids = lonarr(n_buttons)
	for iw = 0, n_buttons-1 do button_wids[iw] = WIDGET_INFO(Event.top, FIND_BY_UNAME=buttons[iw])
	;
	ind = WHERE(button_wids[*] eq wid_button, count)
	if(count ne 0) then begin
		case wid_button of
			button_wids[0]: Change_Trial_Root, Event
			button_wids[1]: Start_Creation, Event
			button_wids[2]: Toggle_Half_Half, Event
			button_wids[3]: Toggle_Save_DS9_Reg, Event
			button_wids[4]: Toggle_No_HWP, Event
			button_wids[5]: Toggle_Poisson, Event
			else: print_text, Event, "Error - button push not recognized"
	    endcase
	endif else print_text, Event, "No button pushed."
end
;
;-----------------------------------------------------------------
pro Tab_1_Handler, Event
	;
	;	handles button and checkbox events generated on the first tab
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	figure out which button was pushed
	;
	buttons = [	"Change_Trial_Run_Directory_Button", $
				"Change_Destination_Directory_Button", $
				"Start_File_Copy_Button" $
			   ]
	wid_button = Event.id
	n_buttons = N_ELEMENTS(buttons)
	button_wids = lonarr(n_buttons)
	for iw = 0, n_buttons-1 do button_wids[iw] = WIDGET_INFO(Event.top, FIND_BY_UNAME=buttons[iw])
	;
	ind = WHERE(button_wids[*] eq wid_button, count)
	if(count ne 0) then begin
		case wid_button of
			button_wids[0]: Change_Trial_Run_Directory, Event
			button_wids[1]: Change_Destination_Directory, Event
			button_wids[2]: Start_File_Copy, Event
			else: print_text, Event, "Error - button push not recognized"
	    endcase
	endif else print_text, Event, "No button pushed."
end
;
;-----------------------------------------------------------------
pro Tab_2_Handler, Event
	;
	;	handles button and checkbox events generated on the first tab
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	figure out which button was pushed
	;
	buttons = [	"T2_Change_Destination_Directory_Button", $
				"T2_Start_File_Fetch_Button", $
				"T2_Change_PPOL_Root_Button", $
				"T2_Obs_Root_List_Listbox" $
			   ]
	wid_button = Event.id
	n_buttons = N_ELEMENTS(buttons)
	button_wids = lonarr(n_buttons)
	for iw = 0, n_buttons-1 do button_wids[iw] = WIDGET_INFO(Event.top, FIND_BY_UNAME=buttons[iw])
	;
	ind = WHERE(button_wids[*] eq wid_button, count)
	if(count ne 0) then begin
		case wid_button of
			button_wids[0]: T2_Change_Destination_Directory, Event
			button_wids[1]: T2_Start_File_Fetch, Event
			button_wids[2]: T2_Change_PPOL_Root, Event
			button_wids[3]: T2_Select_Obs_Root, Event
			else: print_text, Event, "Error - button push not recognized"
	    endcase
	endif else print_text, Event, "No button pushed."
end

;-----------------------------------------------------------------
pro Textbox_Handler, Event
	;
	;	handles events generated on the first tab
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	figure out which textbox was modified
	;
	buttons = [	"Nstars_Textbox", $
				"Beta_Textbox", $
				"M0_Textbox", $
				"M1_Textbox", $
				"Mag_Offset_Textbox", $
				"P0_Textbox", $
				"P1_Textbox", $
				"EPA0_Textbox", $
				"EPA1_Textbox", $
				"Run_Number_Textbox" $
			   ]
	wid_button = Event.id
	n_buttons = N_ELEMENTS(buttons)
	button_wids = lonarr(n_buttons)
	for iw = 0, n_buttons-1 do button_wids[iw] = WIDGET_INFO(Event.top, FIND_BY_UNAME=buttons[iw])
	;
	ind = WHERE(button_wids[*] eq wid_button, count)
	if(count ne 0) then begin
		case wid_button of
			button_wids[0]: Modify_Textbox, Event, "Nstars"
			button_wids[1]: Modify_Textbox, Event, "Beta"
			button_wids[2]: Modify_Textbox, Event, "M0"
			button_wids[3]: Modify_Textbox, Event, "M1"
			button_wids[4]: Modify_Textbox, Event, "Mag_Offset"
			button_wids[5]: Modify_Textbox, Event, "P0"
			button_wids[6]: Modify_Textbox, Event, "P1"
			button_wids[7]: Modify_Textbox, Event, "EPA0"
			button_wids[8]: Modify_Textbox, Event, "EPA1"
			button_wids[9]: Modify_Textbox, Event, "Run Number"
			else: print_text, Event, "Error - textbox not recognized"
	    endcase
	endif else print_text, Event, "No textbox matched."
end
