pro Tab_0_Routines, Event
	;
	;	stub to collect all the mock star creation code
	;
end
;
;-------------------------------------------------------------
pro Change_Trial_Root, Event
	;
	;	uses the file chooser to select a new root directory for the Trial
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	full_path = dialog_pickfile(Title="Select New Trial Root Directory",/directory,$
				path=(*s_ptr).this_dir)
	;
	(*s_ptr).this_dir = full_path
	;
	split_path, Event, (*s_ptr).this_dir, root_path, root_name
	;
	(*w_ptr).Current_Path = root_path
	(*w_ptr).Current_Trial_Name = root_name
	print_text, Event, "New Trial Root Path = "+root_path
	print_text, Event, "New Trial Root Name = "+root_name
	;
	Show_Textboxes, Event
end
;
;-------------------------------------------------------------
pro Start_Creation, Event
	;
	;	begin the mock star generation process
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	;	call the mock star generator
	;
	Create_Mock_Stars,Event
	;
	print_text, Event, 'Mock+Real Star Images Created. Finished'
	print_text, Event, 'Move on to the next Tab'
end
;
;------------------------------------------------------------
pro Toggle_Poisson, Event
	;
	;	toggles the checkbox and flag for full inclusion
	;	of mock star poisson noise in each pixel
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	(*w_ptr).Poisson_Flag = 1L - (*w_ptr).Poisson_Flag
	WIDGET_CONTROL, (*w_ptr).Poisson_Checkbox_wid, SET_BUTTON=(*w_ptr).Poisson_Flag
	print_text, Event, 'Set Poison Checkbox Value to '+STRING((*w_ptr).Poisson_Flag,format='(I1)')
	;
end
;
;------------------------------------------------------------
pro Toggle_Half_Half, Event
	;
	;	toggles the checkbox and flag for the 50/50 polarization
	;	creation option
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	(*w_ptr).Half_Half_Flag = 1L - (*w_ptr).Half_Half_Flag
	WIDGET_CONTROL, (*w_ptr).Half_Half_Checkbox_wid, SET_BUTTON=(*w_ptr).Half_Half_Flag
	print_text, Event, 'Set 50/50 Checkbox Value to '+STRING((*w_ptr).Half_Half_Flag,format='(I1)')
	;
end
;
;------------------------------------------------------------
pro Toggle_Save_DS9_Reg, Event
	;
	;	toggles the checkbox and flag for saving a DS9-type
	;	reg file of the newly created mock stars
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	(*w_ptr).Save_DS9_Reg_Flag = 1L - (*w_ptr).Save_DS9_Reg_Flag
	WIDGET_CONTROL, (*w_ptr).Save_DS9_Reg_Checkbox_wid, SET_BUTTON=(*w_ptr).Save_DS9_Reg_Flag
	print_text, Event, 'Set DS9 Reg File Checkbox Value to '+STRING((*w_ptr).Save_DS9_Reg_Flag,format='(I1)')
	;
end
;-----------------------------------------------------------------
pro Toggle_No_HWP, Event
	;
	;	toggles the checkbox and flag for turning off generation
	;	of mock star images for the 16 HWP images - that is,
	;	selection of this option only puts mock stars in the
	;	deep image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	(*w_ptr).No_HWP_Flag = 1L - (*w_ptr).No_HWP_Flag
	WIDGET_CONTROL, (*w_ptr).No_HWP_Checkbox_wid, SET_BUTTON=(*w_ptr).No_HWP_Flag
	print_text, Event, 'Set No_HWP Checkbox Value to '+STRING((*w_ptr).No_HWP_Flag,format='(I1)')
	;
end


