pro tab_2_routines
	;
	;	stub to hold tab 2 processing programs
	;
end
;
;---------------------------------------------------------------
pro T2_Change_Destination_Directory, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	changes the destination directory (should be of Run type)
	;
	new_dir = dialog_pickfile(Title="Select Destination Trial/Run Directory",/directory)
	(*w_ptr).T2_Destination_Directory = new_dir
	;
	WIDGET_CONTROL, (*w_ptr).T2_Destination_Directory_Textbox_wid, SET_VALUE=new_dir
	print_text, Event, 'Tab 2: Selected Trial/Run destination = '+new_dir
	;
end
;
;---------------------------------------------------------------
pro T2_Start_File_Fetch, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	copies key files from PPOL structure to Trial/Run directory, as long
	;	as both are defined and a root name has been selected.
	;
	test_1 = (*w_ptr).T2_PPOL_Root_Dir eq 'no root'
	test_2 = (*w_ptr).T2_Obs_Root_Name eq 'no obs name'
	test_3 = (*w_ptr).T2_Destination_Directory eq 'no dest'
	if(test_1 or test_2 or test_3) then begin
		print_text, Event, 'Not ready to fetch files from PPOL'
		if(test_1) then print_text, Event, 'Must select PPOL root directory'
		if(test_2) then print_text, Event, 'Must select Observation root name'
		if(test_3) then print_text, Event, 'Must select Trial/Run destination directory'
		print_text, Event, 'Skipping file fetching... try again'
		goto, quick_end
	endif
	;
	;	OK, ready to go. use file search with root name to identify files to move
	;
	ppol_root = (*w_ptr).T2_PPOL_Root_dir
	s8_dir = ppol_root + 'S8_PHOTCAT_Entries' + PATH_SEP()
	;
	obs_root = (*w_ptr).T2_Obs_Root_Name
	;
	dest_dir = (*w_ptr).T2_Destination_Directory
	;
	source_1 = FILE_SEARCH(s8_dir,obs_root+'*.*')
	ns1 = N_ELEMENTS(source_1)
	if(ns1 gt 0) then begin
		FILE_COPY, source_1, dest_dir
		for i=0, ns1-1 do begin
			print_text, event, 'Copied '+source_1[i]+' to Trial/Run destination directory'
		endfor
	endif else begin
		print_text, event, 'No files copied from '+s8_dir
	endelse
	;
	s9_reg_dir = ppol_root + 'S9_Polarimetry' + PATH_SEP()
	;
	source_2 = FILE_SEARCH(s9_reg_dir,obs_root+'*.*')
	ns2 = N_ELEMENTS(source_2)
	if(ns2 gt 0) then begin
		FILE_COPY, source_2, dest_dir
		for i = 0, ns2-1 do begin
			print_text, event, 'Copied '+source_2[i]+' to Trial/Run destination directory'
		endfor
	endif else begin
		print_text, event, 'No files copied from '+s9_reg_dir
	endelse
	;
	s9_dir = ppol_root + 'S9_POLCAT_Entries' + PATH_SEP()
	;
	source_3 = FILE_SEARCH(s9_dir,obs_root+'*.*')
	ns3 = N_ELEMENTS(source_3)
	if(ns3 gt 0) then begin
		FILE_COPY, source_3, dest_dir
		for i = 0, ns3-1 do begin
			print_text, event, 'Copied '+source_3[i]+' to Trial/Run destination directory'
		endfor
	endif else begin
		print_text, event, 'No files copied from '+s9_dir
	endelse
	;
	print_text,Event,"Finished Fetching PPOL Files."
	;
	quick_end:
end
;
;---------------------------------------------------------------
pro T2_Change_PPOL_Root, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	select the root PPOL directory
	;
	new_dir = dialog_pickfile(Title="Select Top-Level PPOL directory",/directory)
	(*w_ptr).T2_PPOL_Root_Dir = new_dir
	;
	WIDGET_CONTROL, (*w_ptr).T2_PPOL_Root_Dir_Textbox_wid, SET_VALUE=new_dir
	print_text, Event, 'Tab 2: Selected PPOL Root = '+new_dir
	;
	;	and, look into POLCAT directory to get root observation name list
	;
	p_dir = new_dir + PATH_SEP() + 'S9_POLCAT_Entries' + PATH_SEP()
	list = FILE_SEARCH(p_dir,'*.dat')
	nlist = N_ELEMENTS(list)
	if(nlist gt 0) then begin
		root_list = FILE_BASENAME(list,'_POLCAT.dat')
		(*w_ptr).T2_Obs_Root_List[0:(nlist-1)] = root_list
		;
		WIDGET_CONTROL, (*w_ptr).T2_Obs_Root_List_Listbox_wid, SET_VALUE=(*w_ptr).T2_Obs_Root_List
		;
		print_text, event, 'Tab 2: found '+STRING(nlist,format='(I)')+' obs root names'
	endif
	;
end
;
;---------------------------------------------------------------
pro T2_Select_Obs_Root, Event
	;
	;	selects the new observation root name from the list of
	;	names
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	identifies index number of new obs root name desired
	;
	ind = Event.index
	;
	if(ind ge 0 and ind le 11) then begin
		;
		new_obs_root = (*w_ptr).T2_Obs_Root_List[ind]
		(*w_ptr).T2_Obs_Root_Name = new_obs_root
		;
		WIDGET_CONTROL, (*w_ptr).T2_Obs_Root_Name_Textbox_wid, SET_VALUE=new_obs_root
		print_text, Event, 'Tab 2: Selected Observation Root Name = '+new_obs_root
		;
	endif else begin
		print_text, Event, 'Did not understand selection. Try again.'
	endelse
end